<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 45.30</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>

    
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Quang Huy</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="CRUDVoucher.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v1</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="CRUDUsers.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v2</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="FilterOrders.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v3</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-12">
            <h1> CRUD Users</h1>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
 <!-- Vùng header -->
 <div class="container-fluid">
  <div class="text-center">
      <h2>Danh sách người dùng đăng ký</h2>
  </div>
  <div class="form-group">
      <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; New User</button>
  </div>
</div>
<!-- Vouche Data Table -->
<div class="container-fluid">
  <table class="table table-bordered table-striped table-hover" id="users-table">
      <thead>
          <tr>
              <th>Id</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Country</th>
              <th>Subject</th>
              <th>Customer Type</th>
              <th>Register Status</th>
              <th>Action</th>
          </tr>
      </thead>
  </table>
</div>

<!-- Vùng modal Create Order -->
<div id="modal-create-order" class="modal fade">
  <div class="modal-dialog">
      <div class="modal-content">
          <div class="modal-header">
              <h5 class="modal-title">Create New User</h5>
              <button class="close" data-dismiss="modal"> &times;</button>
          </div>
          <div class="modal-body">
              <form>
                  <div class="row form-group">
                      <label class="col-form-label col-sm-4">FirstName</label>
                      <div class="col-sm-8">
                          <input class="form-control" id="inp-create-firstname" type="text"
                              placeholder="FirstName">
                      </div>
                  </div>
                  <div class="row form-group">
                      <label class="col-form-label col-sm-4">LastName</label>
                      <div class="col-sm-8">
                          <input class="form-control" type="text" id="inp-create-lastname" placeholder="LastName">
                      </div>
                  </div>
                  <div class="row form-group">
                      <label class="col-form-label col-sm-4">Country</label>
                      <div class="col-sm-8">
                          <select id="select-create-country" class="form-control">
                              <option value="VN">Việt Name</option>
                              <option value="USA">USA</option>
                              <option value="AUS">Australia</option>
                              <option value="CAN">Canada</option>
                          </select>
                      </div>
                  </div>
                  <div class="row form-group">
                      <label class="col-form-label col-sm-4">Customer Type</label>
                      <div class="col-sm-8">
                          <select id="select-create-customer-type" class="form-control">
                              <option value="Standard">Standard</option>
                              <option value="Gold">Gold</option>
                              <option value="Premium">Premium</option>

                          </select>
                      </div>
                  </div>
                  <div class="row">
                      <label class="col-form-label col-sm-4">Subject</label>
                      <div class="col-sm-8">
                          <input class="form-control" type="text" id="inp-create-subject" placeholder="Subject">
                      </div>
                  </div>
              </form>
          </div>
          <div class="modal-footer">
              <button class="btn btn-primary" id="btn-create-user">Insert User</button>
              <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
          </div>
      </div>
  </div>
</div>

<!-- Vùng modal Update User -->
<div>
  <div id="modal-update-user" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
          <div class="modal-content">
              <div class="modal-header">
                  <h5 class="modal-title" id="h5-modal-title">Chi tiết User</h5>
                  <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                  <form>
                      <div class="row form-group">
                          <label class="col-form-label col-sm-4">FirstName</label>
                          <div class="col-sm-8">
                              <input class="form-control" id="inp-update-firstname" type="text"
                                  placeholder="FirstName">
                          </div>
                      </div>
                      <div class="row form-group">
                          <label class="col-form-label col-sm-4">LastName</label>
                          <div class="col-sm-8">
                              <input class="form-control" type="text" id="inp-update-lastname"
                                  placeholder="LastName">
                          </div>
                      </div>
                      <div class="row form-group">
                          <label class="col-form-label col-sm-4">Subject</label>
                          <div class="col-sm-8">
                              <input class="form-control" type="text" id="inp-update-subject"
                                  placeholder="Subject">
                          </div>
                      </div>
                      <div class="row form-group">
                          <label class="col-form-label col-sm-4">Country</label>
                          <div class="col-sm-8">
                              <select id="select-update-country" class="form-control">
                                  <option value="VN">Việt Name</option>
                                  <option value="USA">USA</option>
                                  <option value="AUS">Australia</option>
                                  <option value="CAN">Canada</option>
                              </select>
                          </div>
                      </div>
                      <div class="row form-group">
                          <label class="col-form-label col-sm-4">Customer Type</label>
                          <div class="col-sm-8">
                              <select id="select-update-customer-type" class="form-control">
                                  <option value="Standard">Standard</option>
                                  <option value="Gold">Gold</option>
                                  <option value="Premium">Premium</option>

                              </select>
                          </div>
                      </div>
                      <div class="row form-group">
                          <label class="col-form-label col-sm-4">Register Status</label>
                          <div class="col-sm-8">
                              <select id="select-update-register-status" class="form-control">
                                  <option value="New">New</option>
                                  <option value="Accepted">Accepted</option>
                                  <option value="Denied">Denied</option>

                              </select>
                          </div>
                      </div>

                  </form>
              </div>
              <div class="modal-footer">
                  <button class="btn btn-primary" id="btn-update-user">Update User</button>
                  <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
              </div>
          </div>
      </div>
  </div>
</div>

<!-- Vùng modal Update User -->
<div id="modal-delete-user" class="modal fade">
  <div class="modal-dialog">
      <div class="modal-content">
          <div class="modal-header">
              <h5 class="modal-title">Confirm Xóa User</h5>
              <button class="close" data-dismiss="modal"> &times;</button>
          </div>
          <div class="modal-body">
              <p class="modal-title">Bạn có chắc muốn xóa User này không ?</p>
          </div>
          <div class="modal-footer">
              <button class="btn btn-danger" id="btn-delete-user">Xác nhận</button>
              <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
          </div>
      </div>
  </div>
</div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Devcamp &copy; 2022-2023 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>

<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  $(document).ready(function () {
      const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
      var gNameCol = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
      var gUserID;
      const gCOL_USER_ID = 0;
      const gCOL_FIRST_NAME = 1;
      const gCOL_LAST_NAME = 2;
      const gCOL_COUNTRY = 3;
      const gCOL_SUBJECT = 4;
      const gCOL_CUSTOMER_TYPE = 5;
      const gCOL_REGISTER_STATUS = 6;
      const gCOL_ACTION = 7;



      var gUserTable = $("#users-table").DataTable({
          columns: [
              { data: gNameCol[gCOL_USER_ID] },
              { data: gNameCol[gCOL_FIRST_NAME] },
              { data: gNameCol[gCOL_LAST_NAME] },
              { data: gNameCol[gCOL_COUNTRY] },
              { data: gNameCol[gCOL_SUBJECT] },
              { data: gNameCol[gCOL_CUSTOMER_TYPE] },
              { data: gNameCol[gCOL_REGISTER_STATUS] },
              { data: gNameCol[gCOL_ACTION] },
          ],
          columnDefs: [
              {
                  targets: gCOL_ACTION,
                  defaultContent: `
              <img class="edit-voucher" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
              <img class="delete-voucher" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
              `
              },
          ]
      })
      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

      onPageLoading();
      // U: gán sự kiện cho  Update User - Sửa
      $("#users-table").on("click", ".edit-voucher", function () {
          onBtnEditClick(this);

      })
      // gán sự kiện cho nút Delete
      $("#users-table").on("click", ".delete-voucher", function () {
          onBtnDeleteClick(this);

      })
      // C: gán sự kiện cho  Create - thêm mới
      $("#btn-add-user").on("click", function () {
          onBtnAddNewUser();
      })

      // gán sự kiện cho nút INSERT USER 
      $("#btn-create-user").on("click", function () {
          onBtnInsertUserClick();
      })
      // gán sự kiện cho nút Update User
      $("#btn-update-user").on("click", function () {
          onBtnUpdateUserClick();
      })

      // gán sự kiện cho nút Update User
      $("#btn-delete-user").on("click", function () {
          onBtnDeleteUserClick();
      })



      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
          getAllUser();
      }

      // hàm nút edit 
      function onBtnEditClick(paramEdit) {
          gUserID = getUserIDFormButton(paramEdit)
          console.log("ID được chọn là: " + gUserID)
          getUserByID()

      }

      // hàm nút Delete 
      function onBtnDeleteClick(paramDelete) {
          $("#modal-delete-user").modal("show")
          gUserID = getUserIDFormButton(paramDelete)
          console.log("ID được chọn là: " + gUserID)
      }

      // hàm nút Insert User 
      function onBtnInsertUserClick() {
          var vCreateUser = {
              firstname: "",
              lastname: "",
              country: "",
              customerType: "",
              subject: ""
          }

          getInsertUser(vCreateUser)
          var isCheckInsertUser = validateFormModal(vCreateUser)

          if (isCheckInsertUser) {
              $.ajax({
                  url: gBASE_URL,
                  type: "POST",
                  contentType: "application/json;charset=UTF-8",
                  data: JSON.stringify(vCreateUser),
                  success: function (paramCreate) {
                      console.log(paramCreate)
                      handleInsertUserSuccess(paramCreate)
                  },
                  error: function (paramErr) {
                      console.log(paramErr)
                  }
              })
          }

      }
      // hàm nút Update User 
      function onBtnUpdateUserClick() {
          var vUpdateUser = {
              firstname: "",
              lastname: "",
              subject: "",
              country: "",
              customerType: "",
              registerStatus: "",
          }

          getUpdateUser(vUpdateUser)
          var isCheckUpdateUser = validateFormModal(vUpdateUser)
          if (isCheckUpdateUser) {
              $.ajax({
                  url: gBASE_URL + gUserID,
                  type: "PUT",
                  contentType: "application/json;charset=UTF-8",
                  data: JSON.stringify(vUpdateUser),
                  success: function (paramOjb) {
                     
                      handleUpdateUserSuccess(paramOjb)
                  },
                  error: function (paramErr) {
                      console.log(paramErr.status)
                  }
              })
          }
      }
      // hàm nút xác nhận xóa User
      function onBtnDeleteUserClick() {
          "use strict";
          $.ajax({
              url: gBASE_URL + gUserID,
              type: "DELETE",
              success: function (paramRes) {
                  // B4: xử lý front-end
                  handleDeleteUserSuccess();
              },
              error: function (paramErr) {
                  console.log(paramErr.status);
              }
          });
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

      // hàm load DAta lên table
      function loadDataToTable(paramUser) {
          var vTable = $("#users-table").DataTable()
          vTable.clear()
          vTable.rows.add(paramUser);
          vTable.draw();
      }

      // hàm call ALL API để lấy danh sách user
      function getAllUser() {
          $.ajax({
              url: gBASE_URL,
              type: "GET",
              success: function (paramUser) {
                  
                  loadDataToTable(paramUser)
              },
              error: function (paramError) {
                  console.log(paramError.status)
              }
          })
      }
      function getUserIDFormButton(paramButton) {
          var vRow = $(paramButton).closest("tr")
          var DataRow = gUserTable.row(vRow).data()
          return DataRow.id
      }
      // hàm get User By id
      function getUserByID() {
          $.ajax({
              url: gBASE_URL + gUserID,
              type: "GET",
              success: function (paramUser) {
                  loadDataToModalUpdate(paramUser)
              },
              error: function (paramErr) {
                  console.log(paramErr)
              }

          })
          // hiển thị modal lên
          $("#modal-update-user").modal("show")
      }

      // hàm load data lên modal update
      function loadDataToModalUpdate(paramUser) {
          $("#inp-update-firstname").val(paramUser.firstname);
          $("#inp-update-lastname").val(paramUser.lastname);
          $("#inp-update-subject").val(paramUser.subject);
          $("#select-update-country").val(paramUser.country);
          $("#select-update-customer-type").val(paramUser.customerType);
          $("#select-update-register-status").val(paramUser.registerStatus);


      }
      // hàm nút thêm user được ấn
      function onBtnAddNewUser() {
          $("#modal-create-order").modal("show")
      }

      // hàm thu thập dữ liệu Insert User trên modal
      function getInsertUser(paramCreate) {
          paramCreate.firstname = $.trim($("#inp-create-firstname").val());
          paramCreate.lastname = $.trim($("#inp-create-lastname").val());
          paramCreate.country = $("#select-create-country").val();
          paramCreate.customerType = $("#select-create-customer-type").val();
          paramCreate.subject = $.trim($("#inp-create-subject").val());
      }
      // // hàm thu thập dữ liệu Insert User trên modal
      function getUpdateUser(paramUpdate) {
          paramUpdate.firstname = $.trim($("#inp-update-firstname").val());
          paramUpdate.lastname = $.trim($("#inp-update-lastname").val());
          paramUpdate.subject = $.trim($("#inp-update-subject").val());
          paramUpdate.country = $("#select-update-country").val();
          paramUpdate.customerType = $("#select-update-customer-type").val();
          paramUpdate.registerStatus = $("#select-update-register-status").val();

      }

      // hàm Kiêm tra dữ liệu Form trên modal
      function validateFormModal(paramCreate) {
          if (paramCreate.firstname == "") {
              alert("Hãy nhập FirstName")
              return false
          }
          if (paramCreate.lastname == "") {
              alert("Hãy nhập LastName")
              return false
          }
          if (paramCreate.subject == "") {
              alert("Hãy nhập Subject")
              return false
          }
          return true
      }


      // hàm xử lý front-end khi thêm user thành công
      function handleInsertUserSuccess() {
          alert("Thêm User thành công")
          // Gọi hàm getAllUser() để load lại bảng
          getAllUser();
          // xóa dữ liệu trên modal Create User
          $("#inp-create-firstname").val("");
          $("#inp-create-lastname").val("");
          $("#select-create-country").val("VN");
          $("#select-create-customer-type").val("Standard");
          $("#inp-create-subject").val("");
          // Ẩn Modal Create đi
          $("#modal-create-order").modal("hide")
      }
      // hàm xử lý front-end update user
      function handleUpdateUserSuccess() {
          alert("Update User thành công")
          // Gọi hàm getAllUser() để load lại bảng
          getAllUser();
          // xóa dữ liệu trên modal update User
          $("#inp-update-firstname").val("");
          $("#inp-update-lastname").val("");
          $("#inp-update-subject").val("");
          $("#select-update-country").val("VN");
          $("#select-update-customer-type").val("Standard");
          $("#select-update-register-status").val("New");
          // Ẩn Modal update đi
          $("#modal-update-user").modal("hide")
      }
      // hàm xử lý front-end Delete user
      function handleDeleteUserSuccess() {
          alert("Delete User thành công")
          // Gọi hàm getAllUser() để load lại bảng
          getAllUser();
          // Ẩn Modal delete đi
          $("#modal-delete-user").modal("hide")
      }
  })
</script>
</body>
</html>
